Index: orxonox/branches/dave/src/player.h
===================================================================
--- orxonox/branches/dave/src/player.h	(revision 2746)
+++ orxonox/branches/dave/src/player.h	(revision 2860)
@@ -8,4 +8,5 @@
 
 #include "world_entity.h"
+#include "object.h"
 
 //! Basic controllable WorldEntity
@@ -37,4 +38,5 @@
   float acceleration;
   GLuint objectList;
+  Object* obj;
   
   void move (float time);
Index: orxonox/branches/dave/src/stdincl.h
===================================================================
--- orxonox/branches/dave/src/stdincl.h	(revision 2746)
+++ orxonox/branches/dave/src/stdincl.h	(revision 2860)
@@ -15,4 +15,5 @@
 #include "coordinates.h"
 #include "list.h"
+#include "list_template.h"
 #include "error.h"
 #include "message_structures.h"
Index: orxonox/branches/dave/src/world.cc
===================================================================
--- orxonox/branches/dave/src/world.cc	(revision 2746)
+++ orxonox/branches/dave/src/world.cc	(revision 2860)
@@ -22,4 +22,5 @@
 #include "command_node.h"
 #include "camera.h"
+#include "environment.h"
 
 using namespace std;
@@ -35,5 +36,5 @@
   this->worldName = name;
   this->debugWorldNr = -1;
-  this->entities = new List<WorldEntity>();
+  this->entities = new tList<WorldEntity>();
 }
 
@@ -42,5 +43,5 @@
   this->debugWorldNr = worldID;
   this->worldName = NULL;
-  this->entities = new List<WorldEntity>();
+  this->entities = new tList<WorldEntity>();
 }
 
@@ -74,4 +75,6 @@
   this->bQuitCurrentGame = true;
   this->localCamera->setWorld(NULL);
+  this->entities->clear();
+  Orxonox::getInstance()->get_localinput()->reset();
   this->~World();
 }
@@ -98,13 +101,13 @@
 	    this->pathnodes = new Vector[6];
 	    this->pathnodes[0] = Vector(0, 0, 0);
-	    this->pathnodes[1] = Vector(-100, 40, 0);
-	    this->pathnodes[2] = Vector(-100, 140, 0);
-	    this->pathnodes[3] = Vector(0, 180, 0);
-	    this->pathnodes[4] = Vector(100, 140, 0);
-	    this->pathnodes[5] = Vector(100, 40, 0);
+	    this->pathnodes[1] = Vector(1000, 0, 0);
+	    //	    this->pathnodes[2] = Vector(-100, 140, 0);
+	    //	    this->pathnodes[3] = Vector(0, 180, 0);
+	    //	    this->pathnodes[4] = Vector(100, 140, 0);
+	    //	    this->pathnodes[5] = Vector(100, 40, 0);
 	    
 	    // create the tracks
-	    this->tracklen = 6;
-	    this->track = new Track[6];
+	    this->tracklen = 2;
+	    this->track = new Track[2];
 	    for( int i = 0; i < this->tracklen; i++)
 	      {
@@ -113,5 +116,4 @@
 	    
 	    // create a player
-	    //WorldEntity* myPlayer = (WorldEntity*) this->spawn<Player>();
 	    WorldEntity* myPlayer = new Player();
 	    this->spawn(myPlayer);
@@ -125,4 +127,11 @@
 	    this->localCamera = new Camera(this);
 	    this->getCamera()->bind (myPlayer);	
+
+	    Placement* plc = new Placement;
+	    plc->r = Vector(100, 10, 10);
+	    plc->w = Quaternion();
+	    WorldEntity* env = new Environment();
+	    this->spawn(env, plc);
+
 	    break;
 	  }
@@ -174,6 +183,137 @@
   glNewList (objectList, GL_COMPILE);
   glLoadIdentity();
+  glColor3f(1.0,0,0);
+  glBegin(GL_QUADS);
+  float height [500][50];
+  Vector normal_vectors[500][50];
+  float size = 2;
+    for(int i=0;i<400;i+=1){
+		for(int j=0;j<50;j+=1){
+	normal_vectors[i][j].x=0;
+    normal_vectors[i][j].y=1;
+	normal_vectors[i][j].z=0;
+	
+	
+	
+	}
+	}
+	
+	
+	for ( int i = 0; i<400; i+=1)
+      {
+	for (int j = 0; j<50;j+=1)
+	  {
+	    //height[i][j] = rand()/20046 + (j-25)*(j-25)/30;
+	    height[i][j]=(sin((float)j/3)*rand()*i/182400)*.2;
+	  }
+      }
+	 for(int a=0;a<2;a+=1){
+	 for (int i=1;i<399 ;i+=1 ){
+		 for(int j=1;j<49;j+=1){
+			 height[i][j]=(height[i+1][j]+height[i][j+1]+height[i-1][j]+height[i][j-1])/4;
+
+		 }
+	 }
+	 }
+    //Berechnung von normalen Vektoren
+
+	for(int i=1;i<399;i+=1){
+    for(int j=1;j<49 ;j+=1)
+
+    {
+		Vector* v1 = new Vector (size*i,        size*(j-25),      height[i][j]-20 );
+	    Vector* v2 = new Vector (size*(i+1),    size*(j-25),      height[i+1][j]-20);
+	    Vector* v3 = new Vector (size*(i),    size*(j-24),  height[i][j+1]-20);
+	    Vector* v4 = new Vector (size*(i-1),        size*(j-25),  height[i-1][j]-20);
+		Vector* v5 = new Vector (size*(i), size*(j-26), height[i][j-1]-20);
+		
+		Vector c1 = *v1 - *v2;
+	    Vector c2 = *v1 - *v3;
+	    Vector c3= *v1 - *v4;
+	    Vector c4 = *v1 - *v5;
+	    normal_vectors[i][j]=c1.cross(*v1-*v3)+c2.cross(*v1-*v4)+c3.cross(*v1-*v5)+c4.cross(*v1-*v2);
+		normal_vectors[i][j].normalize();
+	    
+    
+	
+	
+	}
+	}
+	int snowheight=3;
+	for ( int i = 0; i<400; i+=1)
+      {
+	for (int j = 0; j<50;j+=1)
+	  {	  
+	    Vector* v1 = new Vector (size*i,        size*(j-25),      height[i][j]-20 );
+	    Vector* v2 = new Vector (size*(i+1),    size*(j-25),      height[i+1][j]-20);
+	    Vector* v3 = new Vector (size*(i+1),    size*(j-24),  height[i+1][j+1]-20);
+	    Vector* v4 = new Vector (size*(i),        size*(j-24),  height[i][j+1]-20);
+	    float a[3];
+		if(height[i][j]<snowheight){
+		a[0]=0;
+		a[1]=1.0-height[i][j]/10-.3;
+		a[2]=0;
+		glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+		}
+		else{
+		a[0]=1.0;
+		a[1]=1.0;
+		a[2]=1.0;
+		glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+
+		}
+		glNormal3f(normal_vectors[i][j].x, normal_vectors[i][j].y, normal_vectors[i][j].z);
+	    glVertex3f(v1->x, v1->y, v1->z);
+		if(height[i+1][j]<snowheight){
+		a[0]=0;
+		a[1] =1.0-height[i+1][j]/10-.3;
+		a[2]=0;
+		glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+		else{
+		a[0]=1.0;
+		a[1]=1.0;
+		a[2]=1.0;
+		glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+		
+		}
+		glNormal3f(normal_vectors[i+1][j].x, normal_vectors[i+1][j].y, normal_vectors[i+1][j].z);
+	    glVertex3f(v2->x, v2->y, v2->z);
+		if(height[i+1][j+1]<snowheight){
+		a[0]=0;
+		a[1] =1.0-height[i+1][j+1]/10-.3;
+		a[2]=0;
+		glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+		else{
+		a[0]=1.0;
+		a[1]=1.0;
+		a[2]=1.0;
+		glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+		
+		
+		}
+		glNormal3f(normal_vectors[i+1][j+1].x, normal_vectors[i+1][j+1].y, normal_vectors[i+1][j+1].z);
+	    glVertex3f(v3->x, v3->y, v3->z);
+		if(height[i][j+1]<snowheight){
+		a[0]=0;
+		a[1] =1.0-height[i+1][j+1]/10-.3;
+		a[2]=0;
+		glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+		else{
+			a[0]=1.0;
+		a[1]=1.0;
+		a[2]=1.0;
+			glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+		}
+		glNormal3f(normal_vectors[i][j+1].x, normal_vectors[i][j+1].y, normal_vectors[i][j+1].z);
+	    glVertex3f(v4->x, v4->y, v4->z);
+
+	  }
+      }
+glEnd();
+/*  
   glBegin(GL_LINES);
-  
   for( float x = -128.0; x < 128.0; x += 25.0)
     {
@@ -213,6 +353,7 @@
       
     }
-  
+  */  
   //draw track
+  glBegin(GL_LINES);
   glColor3f(0,1,1);
   for( int i = 0; i < tracklen; i++)
@@ -235,18 +376,19 @@
 void World::collide ()
 {
-  List<WorldEntity> *a, *b;
+  /*
+  List *a, *b;
   WorldEntity *aobj, *bobj;
-  
-  a = entities->get_next();
+   
+  a = entities;
   
   while( a != NULL)
     {
-      aobj = a->get_object();
+      aobj = a->nextElement();
       if( aobj->bCollide && aobj->collisioncluster != NULL)
 	{
-	  b = a->get_next();
+	  b = a->nextElement();
 	  while( b != NULL )
 	    {
-	      bobj = b->get_object();
+	      bobj = b->nextElement();
 	      if( bobj->bCollide && bobj->collisioncluster != NULL )
 		{
@@ -260,9 +402,10 @@
 		  }
 		}
-	      b = b->get_next();
+	      b = b->nextElement();
 	    }
 	}
-      a = a->get_next();
-    }
+      a = a->enumerate();
+    }
+  */
 }
 
@@ -275,13 +418,11 @@
   
   // draw entities
-  List<WorldEntity> *l;
   WorldEntity* entity;
   
-  l = entities->get_next();  
-  while( l != NULL ) 
+  entity = this->entities->enumerate();
+  while( entity != NULL ) 
     { 
-      entity = l->get_object();
       if( entity->bDraw ) entity->draw();
-      l = l->get_next();
+      entity = this->entities->nextElement();
     }
   
@@ -303,5 +444,5 @@
 void World::update ()
 {
-  List<WorldEntity> *l;
+  //List<WorldEntity> *l;
   WorldEntity* entity;
   Location* loc;
@@ -309,8 +450,9 @@
   Uint32 t;
   
-  l = entities->get_next();  
-  while( l != NULL ) 
+  //  l = entities->enumerate(); 
+  entity = this->entities->enumerate();
+  while( entity != NULL ) 
     { 
-      entity = l->get_object();
+
       
       if( !entity->isFree() )
@@ -350,5 +492,5 @@
 	}
       
-      l = l->get_next();
+      entity = entities->nextElement();
     }
   
@@ -361,5 +503,5 @@
 void World::time_slice (Uint32 deltaT)
 {
-  List<WorldEntity> *l;
+  //List<WorldEntity> *l;
   WorldEntity* entity;
   float seconds = deltaT;
@@ -367,12 +509,11 @@
   seconds /= 1000;
   
-  l = entities->get_next();  
-  while( l != NULL) 
+  entity = entities->enumerate(); 
+  while( entity != NULL) 
     { 
-      entity = l->get_object();
       entity->tick (seconds);
-      l = l->get_next();
-    }
-  
+      entity = entities->nextElement();
+    }
+
   for( int i = 0; i < tracklen; i++) track[i].tick (seconds);
 }
@@ -411,14 +552,14 @@
 void World::debug()
 {
-  List<WorldEntity> *l;
+  //List<WorldEntity> *l;
   WorldEntity* entity;
   
   printf("counting all entities\n");
-  l = entities->get_next();  
-  while( l != NULL ) 
+  printf("World::debug() - enumerate()\n");
+  entity = entities->enumerate();  
+  while( entity != NULL ) 
     { 
-      entity = l->get_object();
       if( entity->bDraw ) printf("got an entity\n");
-      l = l->get_next();
+      entity = entities->nextElement();
     }
 }
@@ -445,4 +586,7 @@
       // Draw
       display();
+  
+      //for(int i = 0; i < 1000000; i++){}
+
     }
   printf("World|Exiting the main loop\n");
@@ -477,5 +621,5 @@
     {
       Uint32 dt = currentFrame - this->lastFrame;
-      /*
+      
       if(dt > 0)
 	{
@@ -485,7 +629,7 @@
       else
 	{
-	  printf("fps = 1000\n");
-	}
-      */
+	  printf("fps = 1000 but 0ms!\n");
+	}
+      
       this->time_slice (dt);
       this->update ();
@@ -545,14 +689,11 @@
   Location* loc = NULL;
   WorldEntity* owner;
-  //T* entity = new T();
-  entities->add (entity, LIST_ADD_NEXT);
-  //if( loc == NULL)
-  //{
-      zeroloc.dist = 0;
-      zeroloc.part = 0;
-      zeroloc.pos = Vector();
-      zeroloc.rot = Quaternion();
-      loc = &zeroloc;
-      //}
+
+  entities->add (entity);
+  zeroloc.dist = 0;
+  zeroloc.part = 0;
+  zeroloc.pos = Vector();
+  zeroloc.rot = Quaternion();
+  loc = &zeroloc;
   entity->init (loc, owner);
   if (entity->bFree)
@@ -561,4 +702,43 @@
     }
   entity->post_spawn ();
+}
+
+
+void World::spawn(WorldEntity* entity, Location* loc)
+{
+  Location zeroLoc;
+  WorldEntity* owner;
+  this->entities->add (entity);
+  if( loc == NULL)
+    {
+      zeroLoc.dist = 0;
+      zeroLoc.part = 0;
+      zeroLoc.pos = Vector();
+      zeroLoc.rot = Quaternion();
+      loc = &zeroLoc;
+    }
+  entity->init (loc, owner);
+  if (entity->bFree)
+    {
+      this->track[loc->part].map_coords( loc, entity->get_placement());
+    }
+  entity->post_spawn ();
   //return entity;
 }
+
+
+void World::spawn(WorldEntity* entity, Placement* plc)
+{
+  Placement zeroPlc;
+  WorldEntity* owner;
+  if( plc == NULL)
+    {
+      zeroPlc.r = Vector();
+      zeroPlc.w = Quaternion();
+      plc = &zeroPlc;
+    }
+  this->entities->add (entity);
+  entity->init (plc, owner);
+  entity->post_spawn ();
+  //return entity;
+}
Index: orxonox/branches/dave/src/world.h
===================================================================
--- orxonox/branches/dave/src/world.h	(revision 2746)
+++ orxonox/branches/dave/src/world.h	(revision 2860)
@@ -49,9 +49,10 @@
   bool system_command (Command* cmd);
   Camera* getCamera();
-  //private:
 
   void spawn(WorldEntity* entity);
+  void spawn(WorldEntity* entity, Location* loc);
+  void spawn(WorldEntity* entity, Placement* plc);
 
-  List<WorldEntity>* entities;
+  tList<WorldEntity>* entities;
   
   // base level data
Index: orxonox/branches/dave/src/world_entity.cc
===================================================================
--- orxonox/branches/dave/src/world_entity.cc	(revision 2746)
+++ orxonox/branches/dave/src/world_entity.cc	(revision 2860)
@@ -36,6 +36,7 @@
 WorldEntity::WorldEntity (bool isFree) : bFree(isFree)
 {
-	collisioncluster = NULL;
-	owner = NULL;
+  this->bDraw = true;
+  collisioncluster = NULL;
+  owner = NULL;
 }
 
@@ -45,28 +46,28 @@
 WorldEntity::~WorldEntity ()
 {
-	if( collisioncluster != NULL) delete collisioncluster;
+  if( collisioncluster != NULL) delete collisioncluster;
 }
 
 /**
-	\brief get the Location of the WorldEntity
-	\return a pointer to location
+   \brief get the Location of the WorldEntity
+   \return a pointer to location
 */
 Location* WorldEntity::get_location ()
 {
-	return &loc;
+  return &loc;
 }
 
 /**
-	\brief get the Placement of the WorldEntity
-	\return a pointer to placement
+   \brief get the Placement of the WorldEntity
+   \return a pointer to placement
 */
 Placement* WorldEntity::get_placement ()
 {
-	return &place;
+  return &place;
 }
 
 /**
-	\brief query whether the WorldEntity in question is free
-	\return true if the WorldEntity is free or false if it isn't
+   \brief query whether the WorldEntity in question is free
+   \return true if the WorldEntity is free or false if it isn't
 */
 bool WorldEntity::isFree ()
@@ -76,21 +77,21 @@
 
 /**
-	\brief set the WorldEntity's collision hull
-	\param newhull: a pointer to a completely assembled CollisionCluster
-	
-	Any previously assigned collision hull will be deleted on reassignment
+   \brief set the WorldEntity's collision hull
+   \param newhull: a pointer to a completely assembled CollisionCluster
+   
+   Any previously assigned collision hull will be deleted on reassignment
 */
 void WorldEntity::set_collision (CollisionCluster* newhull)
 {
-	if( newhull == NULL) return;
-	if( collisioncluster != NULL) delete collisioncluster;
-	collisioncluster = newhull;
+  if( newhull == NULL) return;
+  if( collisioncluster != NULL) delete collisioncluster;
+  collisioncluster = newhull;
 }
 
 /**
-	\brief this method is called every frame
-	\param time: the time in seconds that has passed since the last tick
-	
-	Handle all stuff that should update with time inside this method (movement, animation, etc.)
+   \brief this method is called every frame
+   \param time: the time in seconds that has passed since the last tick
+   
+   Handle all stuff that should update with time inside this method (movement, animation, etc.)
 */
 void WorldEntity::tick(float time) 
@@ -100,5 +101,5 @@
 /**
    \brief the entity is drawn onto the screen with this function
-
+   
    This is a central function of an entity: call it to let the entity painted to the screen. Just override this function with whatever you want to be drawn.
 */
@@ -108,10 +109,10 @@
 
 /**
-	\brief this function is called, when two entities collide
-	\param other: the world entity with whom it collides
-	\param ownhitflags: flags to the CollisionCluster subsections that registered an impact
-	\param otherhitflags: flags to the CollisionCluster subsections of the other entity that registered an impact
+   \brief this function is called, when two entities collide
+   \param other: the world entity with whom it collides
+   \param ownhitflags: flags to the CollisionCluster subsections that registered an impact
+   \param otherhitflags: flags to the CollisionCluster subsections of the other entity that registered an impact
 
-	Implement behaviour like damage application or other miscellaneous collision stuff in this function
+   Implement behaviour like damage application or other miscellaneous collision stuff in this function
 */
 void WorldEntity::collide(WorldEntity* other, Uint32 ownhitflags, Uint32 otherhitflags) {}
@@ -135,26 +136,26 @@
 
 /**
-	\brief basic initialisation for bound Entities
+   \brief basic initialisation for bound Entities
 */
 void WorldEntity::init( Location* spawnloc, WorldEntity* spawnowner)
 {
-	loc = *spawnloc;
-	owner = spawnowner;
+  loc = *spawnloc;
+  owner = spawnowner;
 }
 
 /**
-	\brief basic initialisation for free Entities
+   \brief basic initialisation for free Entities
 */
 void WorldEntity::init( Placement* spawnplc, WorldEntity* spawnowner)
 {
-	place = *spawnplc;
-	owner = spawnowner;
+  place = *spawnplc;
+  owner = spawnowner;
 }
 
 /**
-	\brief this is called immediately after the Entity has been constructed and initialized
-	
-	Put any initialisation code that requires knowledge of location (placement if the Entity is free) and owner of the entity here.
-	DO NOT place such code in the constructor, those variables are set AFTER the entity is constucted.
+   \brief this is called immediately after the Entity has been constructed and initialized
+   
+   Put any initialisation code that requires knowledge of location (placement if the Entity is free) and owner of the entity here.
+   DO NOT place such code in the constructor, those variables are set AFTER the entity is constucted.
 */
 void WorldEntity::post_spawn ()
@@ -163,9 +164,9 @@
 
 /**
-	\brief this handles incoming command messages
-	\param cmd: a pointer to the incoming Command structure
-	
-	Put all code that handles Command messages here, this will mainly be called by the assigned CommandNode but can also be used
-	to send commands from one WorldEntity to another.
+   \brief this handles incoming command messages
+   \param cmd: a pointer to the incoming Command structure
+   
+   Put all code that handles Command messages here, this will mainly be called by the assigned CommandNode but can also be used
+   to send commands from one WorldEntity to another.
 */
 void WorldEntity::command (Command* cmd)
@@ -174,9 +175,9 @@
 
 /**
-	\brief this is called by the local Camera to determine the point it should look at on the WorldEntity
-	\param locbuf: a pointer to the buffer to fill with a location to look at
+   \brief this is called by the local Camera to determine the point it should look at on the WorldEntity
+   \param locbuf: a pointer to the buffer to fill with a location to look at
 	
-	You may put any Location you want into locbuf, the Camera will determine via the corresponding Track how
-	to look at the location you return with this.
+   You may put any Location you want into locbuf, the Camera will determine via the corresponding Track how
+   to look at the location you return with this.
 */
 void WorldEntity::get_lookat (Location* locbuf)
@@ -185,8 +186,8 @@
 
 /**
-	\brief this method is called by the world if the WorldEntity leaves valid gamespace
-	
-	For free entities this means it left the Track boundaries. With bound entities it means its Location adresses a
-	place that is not in the world anymore. In both cases you might have to take extreme measures (a.k.a. call destroy).
+   \brief this method is called by the world if the WorldEntity leaves valid gamespace
+   
+   For free entities this means it left the Track boundaries. With bound entities it means its Location adresses a
+   place that is not in the world anymore. In both cases you might have to take extreme measures (a.k.a. call destroy).
 */
 void WorldEntity::left_world ()
